function createImageIcon(url) {
    var bodyHeight = 60;
    var bodyWidth = 60;
    var pinHalfWidth = 4;
    var pinHeight = 10;
    
    var width = 60;
    var halfWidth = 30;
    var height = 60;
    
    var markerURL = "http://simile.mit.edu/painter/painter?" + [
        "renderer=map-marker",
        "shape=square",
        "width=" + bodyWidth,
        "height=" + bodyHeight,
        "pinWidth=" + (pinHalfWidth * 2),
        "pinHeight=" + pinHeight,
        "icon=" + encodeURIComponent(url),
        "x.png"
    ].join("&");
    
    var shadowURL = "http://simile.mit.edu/painter/painter?" + [
        "renderer=map-marker-shadow",
        "shape=square",
        "width=" + bodyWidth,
        "height=" + bodyHeight,
        "pinWidth=" + (pinHalfWidth * 2),
        "pinHeight=" + pinHeight,
        ".png"
    ].join("&");
    
    height += pinHeight;
    
    var icon = new GIcon();
    icon.image = markerURL;
    icon.shadow = shadowURL;
    icon.iconAnchor = new GPoint(halfWidth, height);
    icon.imageMap = [ 
        0, 0, 
        0, bodyHeight, 
        halfWidth - pinHalfWidth, bodyHeight,
        halfWidth, height,
        halfWidth + pinHalfWidth, bodyHeight,
        width, bodyHeight,
        width, 0
    ];
    icon.shadowSize = new GSize(width * 1.5, height - 2);
    icon.infoWindowAnchor = new GPoint(halfWidth, 0);
    
    return icon;
}

function createGoogleMyMapsMarker(name, defaultShadow) {
    var prefix = "http://people.csail.mit.edu/dfhuynh/projects/stata-map/images/markers/"; // "http://maps.google.com/mapfiles/ms/micons/"
    var icon = new GIcon(G_DEFAULT_ICON);
    icon.image = prefix + name + ".png";
    icon.shadow = prefix + ((defaultShadow) ? "msmarker" : name) + ".shadow.png";
    icon.iconSize = new GSize(32, 32);
    icon.shadowSize = new GSize(59, 32);
    icon.iconAnchor = new GPoint(16, 32);
    icon.infoWindowAnchor = new GPoint(16, 0);
    icon.imageMap = [ 
        8, 0, 
        8, 32,
        24, 32,
        24, 0
    ];
    
    return icon;
}

function createNewMarker() {
    var prefix = "http://maps.google.com/mapfiles/ms/micons/";
    var icon = new GIcon(G_DEFAULT_ICON);
    icon.image = prefix + "yellow.png";
    icon.shadow = prefix + "msmarker.shadow.png";
    icon.iconSize = new GSize(32, 32);
    icon.shadowSize = new GSize(59, 32);
    icon.iconAnchor = new GPoint(16, 32);
    icon.infoWindowAnchor = new GPoint(16, 0);
    icon.imageMap = [ 
        8, 0, 
        8, 32,
        24, 32,
        24, 0
    ];
    
    return icon;
}
function addSpace(coords, name, color, open) {
    var polygon = new GPolygon(coords, color, 0, 1, color, 0.3);
    map.addOverlay(polygon);
    
    if (name.length > 0) {
        var marker = new GMarker(polygon.getBounds().getCenter());
        var onclick = function() { marker.openInfoWindow(name); };
        GEvent.addListener(marker, "click", onclick);
        map.addOverlay(marker);
        
        if (open) {
            onclick();
        }
    }
}

function addPath(coords, markerIndex, name, color, open) {
    map.addOverlay(new GPolyline(coords, color, 5));
    
    if (name.length > 0) {
        var marker = new GMarker(coords[markerIndex]);
        var onclick = function() { marker.openInfoWindow(name); };
        GEvent.addListener(marker, "click", onclick);
        map.addOverlay(marker);
        
        if (open) {
            onclick();
        }
    }
}

